=== debian/changelog ===
superlu-dist (5.4.0+dfsg1-1) unstable; urgency=medium

  * New upstream version.
    - provides LargeDiag_AWPM as an alternative row permutation
      LargeDiag to LargeDiag_MC64
  * Standards-Version: 4.2.1

 -- Drew Parsons <dparsons@debian.org>  Mon, 01 Oct 2018 11:58:33 +0800
