## superlu-dist 6.0.0+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,31 +8,29 @@
 cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
 
 # Project version numbers
-project(SuperLU_DIST C)
-set(VERSION_MAJOR "5")
-set(VERSION_MINOR "4")
+project(SuperLU_DIST C CXX)
+set(VERSION_MAJOR "6")
+set(VERSION_MINOR "0")
 set(VERSION_BugFix "0")
 set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix})
 
 list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
 
 # Set up options
-option(enable_blaslib   "Build the CBLAS library" ${enable_blaslib_DEFAULT})
 option(enable_doc       "Build doxygen documentation" OFF)
 option(enable_double    "Enable double precision library" ON)
 option(enable_complex16 "Enable complex16 precision library" ON)
 option(enable_tests  "Build tests" ON)
 option(enable_examples  "Build examples" ON)
-option(enable_parmetislib   "Build the ParMETIS library" ON)
+option(TPL_ENABLE_BLASLIB  "Build the CBLAS library" ${enable_blaslib_DEFAULT})
+option(TPL_ENABLE_PARMETISLIB   "Build the ParMETIS library" ON)
+option(TPL_ENABLE_LAPACKLIB "Enable LAPACK library" ON)
 option(TPL_PARMETIS_LIBRARIES "List of absolute paths to ParMETIS link libraries [].")
 option(TPL_PARMETIS_INCLUDE_DIRS "List of absolute paths to ParMETIS include directories [].")
-option(enable_combblaslib   "Build the CombBLAS library" OFF)
+option(TPL_ENABLE_COMBBLASLIB   "Build the CombBLAS library" OFF)
 option(TPL_COMBBLAS_LIBRARIES "List of absolute paths to CombBLAS link libraries [].")
 option(TPL_COMBBLAS_INCLUDE_DIRS "List of absolute paths to CombBLAS include directories [].")
 
-if (NOT enable_combblaslib)
-  SET(XSDK_ENABLE_CXX OFF)
-endif()
 
 ######################################################################
 #
@@ -81,10 +79,8 @@
   set(PROJECT_NAME_LIB_EXPORT libsuperlu_dist.a)
 endif()
 
-if (XSDK_ENABLE_CXX)
-  enable_language (CXX)
-  set(NOCXX FALSE)
-endif()
+set(CMAKE_CXX_STANDARD 11)
+
 if (XSDK_ENABLE_Fortran)
   enable_language (Fortran)
   set(NOFORTRAN FALSE)
@@ -119,12 +115,11 @@
 set(INSTALL_LIB_DIR "${default_install_lib_dir}" CACHE STRING "The folder where libraries will be installed.")
 set(INSTALL_BIN_DIR "${default_install_bin_dir}" CACHE STRING "The folder where runtime files will be installed.")
 
-
 # Set up required compiler defines and options.
 ## get_directory_property( DirDefs COMPILE_DEFINITIONS )
 # set(CMAKE_C_FLAGS "-DDEBUGlevel=0 -DPRNTlevel=0 ${CMAKE_C_FLAGS}")
 if(XSDK_INDEX_SIZE EQUAL 64)
-    message("-- Using 64 bit integer for index size")
+    message("-- Using 64 bit integer for index size.")
 endif()	
 set(CMAKE_C_FLAGS_RELEASE "-O3" CACHE STRING "")
 set(CMAKE_CXX_FLAGS_RELEASE "-O3" CACHE STRING "")
@@ -160,7 +155,7 @@
   endif()
 endif()
 #--------------------- BLAS ---------------------
-if(NOT enable_blaslib)
+if(NOT TPL_ENABLE_BLASLIB)
 #  set(TPL_BLAS_LIBRARIES "" CACHE FILEPATH
 #    "Override of list of absolute path to libs for BLAS.")
   if(TPL_BLAS_LIBRARIES)
@@ -192,8 +187,35 @@
     endif()
 endif()
 
+#--------------------- LAPACK ---------------------
+if(TPL_ENABLE_LAPACKLIB)  ## want to use LAPACK
+  if(TPL_LAPACK_LIBRARIES)
+    set(LAPACK_FOUND TRUE)
+  else()
+    find_package(LAPACK)
+    if(LAPACK_FOUND)
+      set(TPL_LAPACK_LIBRARIES "${LAPACK_LIBRARIES}" CACHE FILEPATH
+        "Set from FindLAPACK.cmake LAPACK_LIBRARIES." FORCE)
+    endif()
+  endif()
+else()  ## not to use LAPACK
+  set(LAPACK_FOUND FALSE)
+  set(HAVE_LAPACK FALSE)
+endif()
+
+if(LAPACK_FOUND)
+    message("-- Using TPL_LAPACK_LIBRARIES='${TPL_LAPACK_LIBRARIES}'")
+    set(LAPACK_LIB ${TPL_LAPACK_LIBRARIES})
+    # fix up LAPACK library name
+    string (REPLACE ";" " " LAPACK_LIB_STR "${LAPACK_LIB}")
+    set(LAPACK_LIB_EXPORT ${LAPACK_LIB_STR})
+    set(HAVE_LAPACK TRUE)
+else()
+    message("-- Will not link with LAPACK.")
+endif()
+
 #--------------------- ParMETIS ---------------------
-if (enable_parmetislib)   ## want to use parmetis
+if (TPL_ENABLE_PARMETISLIB)   ## want to use parmetis
   if (NOT TPL_PARMETIS_LIBRARIES)
     message(FATAL_ERROR "TPL_PARMETIS_LIBRARIES option should be set for PARMETIS support to be enabled.")
   endif()
@@ -208,19 +230,18 @@
     set(CMAKE_C_FLAGS "-I${dir} ${CMAKE_C_FLAGS}")
   endforeach()
 
-  message("-- Enabled support for PARMETIS")
+  message("-- Enabled support for PARMETIS.")
   set(PARMETIS_FOUND TRUE)
 
   set(PARMETIS_LIB ${TPL_PARMETIS_LIBRARIES})
   # fix up PARMETIS library names
   string (REPLACE ";" " " PARMETIS_LIB_STR "${PARMETIS_LIB}")
   set(PARMETIS_LIB_EXPORT ${PARMETIS_LIB_STR})
-
 else()
   message("-- Will not link with ParMETIS.")
 endif()
 
-if(enable_parmetislib AND NOT PARMETIS_FOUND)
+if(TPL_ENABLE_PARMETISLIB AND NOT PARMETIS_FOUND)
   find_package(ParMETIS)
   if(PARMETIS_FOUND)
     set(PARMETIS_LIB ParMETIS::ParMETIS)
@@ -233,7 +254,7 @@
 endif()
 
 #--------------------- CombBLAS ---------------------
-if (enable_combblaslib)   ## want to use CombBLAS
+if (TPL_ENABLE_COMBBLASLIB)   ## want to use CombBLAS
   if (NOT TPL_COMBBLAS_LIBRARIES)
     message(FATAL_ERROR "TPL_COMBBLAS_LIBRARIES option should be set for COMBBLAS support to be enabled.")
   endif()
