=== debian/changelog ===
superlu-dist (6.0.0+dfsg1-2) unstable; urgency=medium

  * disable ParMETIS support
    - true ParMETIS is not available (nonfree), but SCOTCH's emulation
      triggers a segfault in sp_colorder.c:163 since SCOTCH fails to
      update perm_c (permtab/peritab in
      library_graph_order.c:SCOTCH_graphOrderComputeList)

 -- Drew Parsons <dparsons@debian.org>  Sat, 20 Oct 2018 19:15:25 +0800

superlu-dist (6.0.0+dfsg1-1exp2) experimental; urgency=medium

  * merge default row permutations (NOROWPERM) and refresh
    only_short_tests.patch from 5.4.0+dfsg1-2..5.

 -- Drew Parsons <dparsons@debian.org>  Mon, 15 Oct 2018 13:58:42 +0800

superlu-dist (6.0.0+dfsg1-1exp1) experimental; urgency=medium

  * New upstream version
    - new ABI version 6
    - improved strong scaling of the triangular solve
    - now includes C++ code (build with mpic++)

 -- Drew Parsons <dparsons@debian.org>  Mon, 01 Oct 2018 13:01:38 +0800

superlu-dist (5.4.0+dfsg1-5) unstable; urgency=medium

  * propagate use of DEB_HOST_GNU_TYPE consistently throughout rules

 -- Drew Parsons <dparsons@debian.org>  Wed, 10 Oct 2018 02:01:14 +0800

superlu-dist (5.4.0+dfsg1-4) unstable; urgency=medium

  * build dir is DEB_HOST_GNU_TYPE not DEB_BUILD_MULTIARCH
    (see /usr/share/perl5/Debian/Debhelper/Buildsystem.pm)

 -- Drew Parsons <dparsons@debian.org>  Wed, 10 Oct 2018 00:03:03 +0800

superlu-dist (5.4.0+dfsg1-3) unstable; urgency=medium

  * use DEB_BUILD_MULTIARCH to determine build dir
  * set OMPI_MCA_rmaps_base_oversubscribe=1 to enable tests to run on
    smaller build systems

 -- Drew Parsons <dparsons@debian.org>  Tue, 09 Oct 2018 20:46:33 +0800

superlu-dist (5.4.0+dfsg1-2) unstable; urgency=medium

  * new Debian patches:
    - rowperm_default_NOROWPERM_not_MC64.patch: set default row
      permutation algorithm to NOROWPERM since MC64 is not available.
      MC64 has been removed since it uses code under a non-free HSL
      licence which does not permit redistribution. Document in
      README.Debian.
    - scotch_metis_v3.patch: use METIS v3 interface (non-NULL
      options). The METIS interface is handled by SCOTCH, which
      segfaults if NULL is sent to METIS_NodeND.
    - only_short_tests.patch: only run tests up to 2 rows or columns.
      Longer tests take 1000 sec or timeout, so drop them.
  * mark packages Multi-Arch: same
  * set MPIEXEC_PREFLAGS=--allow-run-as-root to allow build-time tests
    with fakeroot
  * run one built-time test at a time (tests themselves are MPI parallel,
    processors will get overloaded and tests will time out if multiple
    tests are run)
  * libsuperlu-dist-dev: install test files to
    /usr/lib/${DEB_HOST_MULTIARCH}/superlu-dist/tests
  * include debian/tests to run tests with autopkgtest

 -- Drew Parsons <dparsons@debian.org>  Mon, 08 Oct 2018 19:47:07 +0800
