=== debian/control ===
--- 
+++ 
@@ -6,9 +6,7 @@
 	cmake (>= 2.8.12),
 	mpi-default-dev, mpi-default-bin,
 	gfortran,
-	libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
-	libscotchparmetis-dev | libparmetis-dev,
-	libscotchmetis-dev | libmetis-dev
+	libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so
 Standards-Version: 4.2.1
 Section: libs
 Homepage: http://crd-legacy.lbl.gov/~xiaoye/SuperLU/#superlu_dist
@@ -18,7 +16,10 @@
 Package: libsuperlu-dist-dev
 Section: libdevel
 Architecture: any
-Depends: libsuperlu-dist5 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
+Depends: libsuperlu-dist6 (= ${binary:Version}),
+ ${shlibs:Depends},
+ ${misc:Depends}
 Description: Highly distributed solution of sparse linear equations
  SuperLU is a general purpose library for the direct solution of large,
  sparse, nonsymmetric systems of linear equations. The library is
@@ -48,8 +49,9 @@
  This package provides development files for building client 
  applications against superlu-dist.
 
-Package: libsuperlu-dist5
+Package: libsuperlu-dist6
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Highly distributed solution of sparse linear equations
  SuperLU is a general purpose library for the direct solution of large,
