=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 #export DH_VERBOSE = 1
 
 export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 # see FEATURE AREAS in dpkg-buildflags(1)
 #export DEB_BUILD_MAINT_OPTIONS = hardening=+all
@@ -16,7 +17,9 @@
 
 # Allow test programs that use OpenMPI to run
 export OMPI_MCA_plm_rsh_agent=/bin/false
+export OMPI_MCA_rmaps_base_oversubscribe=1
 
+export BUILDDIR = obj-$(DEB_HOST_GNU_TYPE)
 
 %:
 	dh $@ --buildsystem=cmake
@@ -32,16 +35,25 @@
 override_dh_auto_configure:
 	dh_auto_configure -- \
 	    -DBUILD_SHARED_LIBS=ON -DCMAKE_SKIP_RPATH=ON \
-	    -DCMAKE_C_COMPILER=mpicc -DCMAKE_FORTRAN_COMPILER=mpifort \
+	    -DCMAKE_C_COMPILER=mpicc \
+	    -DCMAKE_CXX_COMPILER=mpic++ \
+	    -DCMAKE_FORTRAN_COMPILER=mpifort \
+	    -DMPIEXEC_PREFLAGS=--allow-run-as-root \
 	    -DCMAKE_INSTALL_INCLUDEDIR=include/superlu-dist \
 	    -Denable_blaslib=OFF -DTPL_BLAS_LIBRARIES=/usr/lib/$(DEB_HOST_MULTIARCH)/libblas.so \
-	    -Denable_parmetislib=ON \
-	    -DTPL_PARMETIS_INCLUDE_DIRS="/usr/include/scotch;/usr/include/parmetis;/usr/include/metis" \
-	    -DTPL_PARMETIS_LIBRARIES="/usr/lib/$(DEB_HOST_MULTIARCH)/libparmetis.so;/usr/lib/$(DEB_HOST_MULTIARCH)/libmetis.so" \
+	    -DTPL_ENABLE_PARMETISLIB=OFF \
 	  || /bin/true
 
 
 # set LD_LIBRARY_PATH to test against the libsuperlu_dist.so just built
 override_dh_auto_test:
-	export LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/SRC:$${LD_LIBRARY_PATH}; \
-	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH} dh_auto_test || /bin/true
+	export LD_LIBRARY_PATH=$(CURDIR)/$(BUILDDIR)/SRC:$${LD_LIBRARY_PATH}; \
+	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH} dh_auto_test --max-parallel=1 || /bin/true
+
+override_dh_install:
+	dh_install
+	for testfile in $$( find debian/libsuperlu-dist-dev -name CTestTestfile.cmake ); do \
+	    sed -r "s|$(CURDIR)|<<builddir>>/superlu-dist|; \
+		    s|(.*)\".*/(EXAMPLE/.*ua)|\1\"/usr/lib/$(DEB_HOST_MULTIARCH)/superlu-dist/tests/\2|" \
+		-i $$testfile; \
+	done
