## superlu-dist 6.1.0+dfsg1

=== debian/changelog ===
superlu-dist (6.1.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches and update build_with_combblas.patch to remove explicit
    flag -std=c++11 (std already updated to c++14 by CMAKE_CXX_STANDARD)

 -- Drew Parsons <dparsons@debian.org>  Tue, 11 Dec 2018 13:49:38 +0800

superlu-dist (6.0.0+dfsg1-3) unstable; urgency=medium

  * Build with CombBLAS support
    - Build-Depends: libcombblas-dev
    - debian patch build_with_combblas.patch:
      * applied C++14 standard (needed by CombBLAS)
      * indicate path to BipartiteMatchings header files
    - activate by setting RowPerm=LargeDiag_AWPM (square matrices only)

 -- Drew Parsons <dparsons@debian.org>  Sat, 24 Nov 2018 23:19:00 +0800
