=== debian/control ===
--- 
+++ 
@@ -6,7 +6,8 @@
 	cmake (>= 2.8.12),
 	mpi-default-dev, mpi-default-bin,
 	gfortran,
-	libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so
+	libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
+	libcombblas-dev (>= 1.6.2-3)
 Standards-Version: 4.2.1
 Section: libs
 Homepage: http://crd-legacy.lbl.gov/~xiaoye/SuperLU/#superlu_dist
