## superlu-dist 6.1.1%2Bdfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,8 +10,8 @@
 # Project version numbers
 project(SuperLU_DIST C CXX)
 set(VERSION_MAJOR "6")
-set(VERSION_MINOR "0")
-set(VERSION_BugFix "0")
+set(VERSION_MINOR "1")
+set(VERSION_BugFix "1")
 set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix})
 
 list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
@@ -49,6 +49,11 @@
 set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)    ## ????
 set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
 
+# set the position independent code property on all targets, so that
+# -fPIC is added in compiler flag.
+set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+
+
 #---- For shared library
 
 # use, i.e. don't skip the full RPATH for the build tree
@@ -118,6 +123,7 @@
 # Set up required compiler defines and options.
 ## get_directory_property( DirDefs COMPILE_DEFINITIONS )
 # set(CMAKE_C_FLAGS "-DDEBUGlevel=0 -DPRNTlevel=0 ${CMAKE_C_FLAGS}")
+set(CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
 if(XSDK_INDEX_SIZE EQUAL 64)
     message("-- Using 64 bit integer for index size.")
 endif()	
@@ -200,7 +206,7 @@
   endif()
 else()  ## not to use LAPACK
   set(LAPACK_FOUND FALSE)
-  set(HAVE_LAPACK FALSE)
+  set(SLU_HAVE_LAPACK FALSE)
 endif()
 
 if(LAPACK_FOUND)
@@ -209,7 +215,7 @@
     # fix up LAPACK library name
     string (REPLACE ";" " " LAPACK_LIB_STR "${LAPACK_LIB}")
     set(LAPACK_LIB_EXPORT ${LAPACK_LIB_STR})
-    set(HAVE_LAPACK TRUE)
+    set(SLU_HAVE_LAPACK TRUE)
 else()
     message("-- Will not link with LAPACK.")
 endif()
